#if!defined (_construction_h_)

#define _construction_h_

#include<fstream>
#include<iostream>
using namespace std;

#include "symmetry.h"
#include "state.h"
#include "state_list.h"
#include "sector.h"
#include "quantum_operator.h"




// construction of the new base states from the current and the local states

extern int trial_state_no; 
extern double sqrt_lambda; 
extern double lambda; 

void set_original_sectors(int state_no, 
			  state *states_array,
			  int * &block_original_sector_array, 
			  int * &block_original_sector_index_array); 

int get_sectors_no(int state_no, 
		   state* states_array); 


void set_sectors_representation_index(int symmetry_no, 
				      symmetry *symmetry_types,
				      int state_no, 
				      state * states_array, 
				      int sector_no,
				      sector_properties * &sectors_properties_array);


int  get_local_degeneracy(int symmetry_no, 
			  symmetry* symmetry_types, 
			  int sector_no, 
			  sector_properties* sectors_properties_array); 


void create_new_block_states_with_list(int symmetry_no, 
				       symmetry * symmetry_types, 
				       int block_state_no, 
				       state * block_states_array, 
				       int local_state_no,
				       state * local_states_array, 
				       int & new_block_state_no, 
				       state *& new_block_states_array);


void create_new_block_states(int symmetry_no, 
			     symmetry * symmetry_types, 
			     int block_state_no, 
			     state * block_states_array, 
			     int local_state_no,
			     state * local_states_array, 
			     int & new_block_state_no, 
			     state *& new_block_states_array);


void create_new_block_hamiltonian(int iteration_index, 
				  
				  int symmetry_no, 
				  symmetry * symmetry_types, 
				  
				  int new_block_sector_no, 
				  sector_properties * new_block_sectors_properties_array, 
				  
				  quantum_operator & new_block_hamiltonian,
				  
				  state * new_block_states_array,
				  state * block_states_array, 
				  state * local_states_array, 

				  quantum_operator &  block_hamiltonian, 
				  
				  int hopping_operator_no,

				  double **  hopping_couplings_array, 
				  double **  on_site_energies_array,

				  quantum_operator* block_hopping_operators, 
				  quantum_operator* local_hopping_operators, 
				  quantum_operator* local_hopping_hamiltonians,
				  
				  sector_properties *local_sectors_properties_array); 


void create_new_block_hopping_operator(int iteration_index,
				       
				       int symmetry_no, 
				       symmetry * symmetry_types, 
				       
				       int new_block_sector_no, 
				       
				       sector_properties * new_block_sectors_properties_array, 
				       
				       quantum_operator & new_block_hopping_operator, 
				       
				       state * new_block_states_array,
				       state * block_states_array, 
				       state * local_states_array, 
				       
				       quantum_operator & block_hopping_operator, 
				       quantum_operator & local_hopping_operator,
				       
				       sector_properties * local_sectors_properties_array
				       ); 


void create_new_block_spectral_operator(int symmetry_no, 
				  symmetry * symmetry_types, 

				  int new_block_sector_no, 
				  sector_properties * new_block_sectors_properties_array,

				  quantum_operator & new_block_spectral_operator, 

				  state * new_block_states_array,
				  state * block_states_array, 
				  state * local_states_array, 

				  quantum_operator & block_spectral_operator); 


void set_hopping_couplings_and_on_site_energies_array(int iteration_no, 
						      int hopping_operator_no,
						      double ** &  hopping_couplings_array, 
						      double ** &  on_site_energies_array); 

#endif
