#if!defined (_green_function_h_)

#define _green_function_h_
#include <assert.h>
#include<fstream>
#include<iostream>
using namespace std;

#include "symmetry.h"
#include "state.h"
#include "clebsch_gordan.h"
#include "quantum_operator.h"
#include "in_out.h"
#include "transformation.h"
#include "hilbert_transform.h"

extern const int buffer_size;
extern char buffer[5000];
extern char word[5000];
extern int word_offset;

extern char spectral_function_file_name[400]; 
extern char green_function_file_name[400]; 

extern "C" void spline(double x[], double y[], int n, double yp1, double ypn, double y2[]);
extern "C" void splint(double xa[], double ya[], double y2a[], int n, double x, double *y); 

extern "C" double *dvector(long nl, long nh); 
extern "C" void free_dvector(double *v, long nl, long nh); 


void generate_green_function_dmnrg_quadrature (double b,
					       quantum_operator & spectral_operator_A, 
					       quantum_operator & spectral_operator_B
					       );


void generate_green_function_nrg_odd_quadrature (double b,
						 quantum_operator & spectral_operator_A, 
						 quantum_operator & spectral_operator_B
						 );

void generate_green_function_nrg_even_quadrature (double b,
						  quantum_operator & spectral_operator_A, 
						  quantum_operator & spectral_operator_B
						  );



#endif 

