
#if!defined (_llvector_h_)

#define _llvector_h_

#include<fstream>
#include<iostream>
#include<stdlib.h>
using namespace std;


/*************************************************************************
llvector class:
this is a class of integers, similar with an array of integers

members:	
	size - is the size of the array. the index of elements
		goes from 0 to size-1. 
	ptr - 	this is the pointer to the vector. 

****************************************************************************/

class llvector{
 protected:
  int size; 
  int * ptr; 
 public: 

/****************************************************************************
****************************************************************************
****************************************************************************

                    CONSTRUCTORS AND DESTRUCTORS. 

****************************************************************************
****************************************************************************
****************************************************************************/







/****************************************************************************

Implicit constructor for the llvector class. 

input variables = none

output variables  = none

return = none

What it does:
     set the 'size' to zero and 'aptr' to NULL. 

how to call:
     llvector(); 
   
****************************************************************************/

  llvector(); 


/****************************************************************************
Implicit constructor for the llvector class. 


input variables  = 1
       int new_size - this is the size of the llvector class. 

output variables = none

return = none

What it does:
     set the 'size' to new_size and correspondendly allocates a pointer for 'aptr'
     of the proper size. 

how to call: 
     llvector(int new_size); 

****************************************************************************/

  llvector(int new_size); 


/****************************************************************************
Implicit destructor for the class. 

input variables = none 

output variables = none

return = none

What it does:
     Destroys the class llvector. 

how to call:
    ~llvector(); 

****************************************************************************/

  ~llvector();





/****************************************************************************
****************************************************************************
****************************************************************************

                    MEMBERS FUNCTIONS

****************************************************************************
****************************************************************************
****************************************************************************/


/****************************************************************************
input variables =one
      int new_size - size of the allocated llvector class

output variables = none

return =void

What it does:
     'allocate' allocates a llvector with size new_size, 
     similar to a constructor. At the same time all the elements 
     of the llvector class are set to zero. 
how to call:
void allocate(int new_size); 

****************************************************************************/

 
  void allocate(int new_size); 


/****************************************************************************
input variables = none

output variables = none

return =void; 

What it does:
     'clear' destroys the llvector class similar with a destructor. 

how to call: 
    void clear(); 

****************************************************************************/

  void clear();


/****************************************************************************
input variables = none

output variables = none

return = a pointer to an integer; 

What it does:
     'get_ptr' returns the 'ptr' variable that is a pointer to an int 

how to call: 
    int * get_ptr();
 
****************************************************************************/

  int * get_ptr(void);


/****************************************************************************
input variables = none

output variables = none

return = an integer; 

What it does:
     'get_size' returns the the size of the llvector class, that is 
     the variable 'size'. 

how to call: 
    int get_size();
 
****************************************************************************/

  int  get_size(); 

/****************************************************************************
input variables = one
     ostream & os - the stream where the class is printer 

output variables = none

return = a reference to a stream; 

What it does:
     'print' returns the stream where the class is printed      

how to call: 
    ostream & print(ostream & ); 
 
****************************************************************************/

  ostream & print(ostream & ); 


/****************************************************************************
*****************************************************************************
*****************************************************************************

                                OPERATORS

*****************************************************************************
*****************************************************************************
*****************************************************************************/


/****************************************************************************
input variables = one
     const int new_value - this is the new value of all the elements

output variables = none

return = a reference to the llvector class; 

What it does:
     '=' atributes to all the elements of the llvector class a given value new_value

how to call: 
    llvector & operator = (const int new_value);
 
****************************************************************************/

  llvector & operator = (const int ); 

/****************************************************************************
input variables = none

output variables = none

return = a reference to the llvector class; 

What it does:
     '++' increments with one all the elements of the llvector. 
how to call: 
    llvector & operator ++ (void);
 
****************************************************************************/

  llvector & operator ++ ();   


/****************************************************************************
input variables = one
      int i - the 'i'-th element from the pointer ptr. 
output variables = none

return = the 'i'-th element from the pointer ptr.

What it does:
     '[]' returns the 'i'-th element from the pointer ptr.
how to call: 
    llvector & operator [] (int);
 
****************************************************************************/

  int & operator [] (int ); 

/****************************************************************************
input variables = one
      llvector & V- a reference to a llvector class. 

output variables = none

return = the reference to the llvector class. 

What it does:
     '=' is similar with a copy constructor so the input llvector  
      reference variable is copied in the *this variable

how to call: 
     llvector & operator = (llvector & );     
 
****************************************************************************/

  llvector & operator = (llvector & ); 

/****************************************************************************
input variables = one
      llvector & V  - a reference to a llvector class. 

output variables = none

return = 1 if the V is equal with the present llvector class variable
         0 if V does not match with the present class element. 

What it does:
     '==' tests if two llvector variables are equal in all respects. If they are
     then returns 1 otherwise returns 0. 

how to call: 
     int operator == (llvector & );     
 
****************************************************************************/

  int  operator == (llvector &); 


/****************************************************************************
input variables = one
      llvector & V  - a reference to a llvector class. 

output variables = none

return = 0 if the V is equal with the present llvector class variable
         1 if V does not match with the present class element. 

What it does:
     '!=' tests if two llvector variables are not equal. If they are not 
     equal then returns 1 otherwise returns 0. 

how to call: 
     int operator != (llvector & );     
 
****************************************************************************/

  int operator != (llvector & ); 


/****************************************************************************
input variables = one
      llvector & V  - a reference to a llvector class. 

output variables = none

return = 1 if the the size of the V vector is larger than the size of the
        present class or, if the sizes are the same, then compares the 
        elements. 
        0 otherwise. 
What it does:
     '<' tests firt the sizes of the classes variables and then the
     corresponding elements one by one. 

how to call: 
     int operator < (llvector & );     
 
****************************************************************************/

  int operator < (llvector &); 


/****************************************************************************
input variables = one
      llvector & V - a reference to a llvector class. 

output variables = none

return = 1 if the the size of the V vector is smaller than the size of the
        present class or, if the sizes are the same, then compares the 
        elements. 
        0 otherwise. 

What it does:
     '>' tests firt the sizes of the classes variables and then the
     corresponding elements one by one. 

how to call: 
     int operator > (llvector & );     
 
****************************************************************************/

  int operator > (llvector &); 


/****************************************************************************
*****************************************************************************
*****************************************************************************

                                FRIEND FUNCTIONS.

*****************************************************************************
*****************************************************************************
*****************************************************************************/


/****************************************************************************
input variables = two
      ostream & os -stream where the llvector class is printed
      llvector V  - a reference to a llvector class

output variables = none

return = the stream where the llvector class is printed

What it does:
     '<<' print the V llvector into the os stream. This can be a file
     or any other output redirected. 

how to call: 
     friend  ostream & operator << (ostream & , llvector & ); 
 
****************************************************************************/


  friend  ostream & operator << (ostream & , llvector & ); 

}; //end llvector class. 


#endif

