#if!defined (_mapping_h_)

#define _mapping_h_
#include <assert.h>
#include <fstream>
#include <iostream>
#include <stdio.h>
#include <gmp.h>

#include "in_out.h"
#include "density_of_states.h"


using namespace std;

extern char density_of_states_file_name[400]; 
extern char mapping_folder_name[400]; 
extern int dos_points_no_per_interval;
extern char gamma_file_name[400]; 
extern char zeta_file_name[400]; 
extern char on_site_energies_file_name[400]; 
extern char hopping_couplings_file_name[400]; 
extern double hybridization_potential; 

extern double *dos_energy_array;
extern double **dos_hopping_operator_array; 

extern long dos_energy_no; 

extern "C" void spline(double x[], double y[], int n, double yp1, double ypn, double y2[]);
extern "C" void splint(double xa[], double ya[], double y2a[], int n, double x, double *y); 


void read_density_of_states();


void generate_initial_density_of_states(int dos_points_no_per_interval,
					int self_consistancy_index,
					int hopping_operator_no); 


void generate_gamma_and_zeta(int dos_points_no_per_interval,
			     int self_consistancy_index, 
			     int hopping_operator_no);

void generate_hoppings_and_on_site_energies(int self_consistancy_index,
					    int hopping_operator_no);



#endif 
