
#if!defined (_memory_h_)

#define _memory_h_


#include <stdio.h>
#include "sector.h"
#include "quantum_operator.h"
#include "symmetry.h"


typedef char name[256];
extern name *couplings_name;

extern int symmetry_no;
extern int coupling_no;
extern int local_coupling_no;
extern int operator_no;
extern int local_state_no;
extern int hopping_operator_no;
extern int spectral_operator_no; 
extern int static_operator_no;
extern int spectral_function_no;
extern double * couplings;
extern double * couplings_rescaled;
extern double * local_couplings; 

extern symmetry * symmetry_types; 
extern quantum_operator *block_hamiltonian_terms; 

extern quantum_operator *local_hamiltonian_terms; 
extern quantum_operator *local_hopping_hamiltonians;

extern quantum_operator new_block_hamiltonian;
extern quantum_operator block_hamiltonian;
extern quantum_operator local_hamiltonian;


extern quantum_operator* new_block_spectral_operators;
extern quantum_operator* new_block_static_operators;
extern quantum_operator* new_block_hopping_operators;
extern quantum_operator* block_hopping_operators;
extern quantum_operator* block_spectral_operators; 
extern quantum_operator* block_static_operators;
extern quantum_operator* local_hopping_operators; 


extern state * new_block_states_array ;
extern sector_properties *new_block_sectors_properties_array; 


extern state * local_states_array;
extern state * local_states_array_copy;
extern sector_properties *local_sectors_properties_array; 


extern state * block_states_array; 
extern state * block_states_array_copy ; 
extern sector_properties *block_sectors_properties_array ;

extern double * new_block_energies_array; 
extern double *sorted_new_block_energies_array; 
extern double *block_energies_array ; 
extern double *sorted_block_energies_array; 


extern unsigned long * new_block_energies_index;
extern unsigned long * block_energies_index ; 
extern sector * transformation_sectors ;

extern int *spectral_function_index[2];

extern double **hopping_couplings_array;
extern double **on_site_energies_array;
extern double **static_average_spectral_operators_array; 


extern int *block_original_sector_array; 
extern int *block_original_sector_index_array;
void clear_all_memory();


#endif



