#if!defined (_quantum_operator_h_)

#define _quantum_operator_h_

#include<fstream>
#include<iostream>
using namespace std;

#include <string.h>
#include "llvector.h"
#include "sector.h"


/*********************************************************************
class operator

    variables definition
        
        representation_index - these are the quantum numbers describing the states. 
        sectors_matrix[][] represents a matrix af sectors 
        name represents the name of the operator.
        sgn -is the sign of the state.
********************************************************************/



class quantum_operator{
 protected:        
  llvector representation_index; 
  sector** sectors_matrix; 
  char* name;
  int sgn;

 public:

  quantum_operator();
  ~quantum_operator(); 
  void activate(int ); 
  void allocate_sectors_matrix(int );
  void clear();
  void clear_sectors_matrix();
  int get_representation_index(int); 
  void set_representation_index(int ,int); 
  int get_representation_index_size(); 
  void set_representation_index(llvector & ) ; 
  llvector & get_representation_index();  
  sector** get_sector_matrix(); 
  char* get_name();
  void set_name(char *); 
  int get_sgn();
  void set_sgn(int); 
};


#endif

