#if!defined (_sector_h_)

#define _sector_h_

#include<fstream>
#include<iostream>
using namespace std;

#include "dmatrix.h"
#include "llvector.h"


class sector {
 protected:      

  int height, width; 
  llvector representation_index[2]; 
  dmatrix matrix;
 
 public:
  sector(); 
  ~sector();
  void activate(int);
  void allocate_matrix();    
  void delete_matrix(void); 
  void clear(void); 

  int get_activation_state();      
  int get_height(); 
  int get_width(); 
  dmatrix & get_matrix(); 
  int get_representation_index(int , int); 
  llvector & get_representation_index(int ); 

  void set_size (int dim1, int dim2); 
  void set_matrix_element(int, int, double); 
  void set_representation_index(int , int , int); 
  void set_representation_index(int ,  llvector & ); 


};


typedef struct{
  int first_state;
  int dimension; 
  llvector representation_index; 
  int degeneracy; 
  
}sector_properties;

#endif 
