#if!defined _ectral_function_h_
#define  _spectra_function_h_

#include <assert.h>
#include<fstream>
#include<iostream>
using namespace std;


#include<math.h>
#include<string.h>
#include "symmetry.h"
#include "state.h"
#include "clebsch_gordan.h"
#include "quantum_operator.h"
#include "in_out.h"
#include "transformation.h"


// calculating the coefficient, coming from the Clebsch-Gordan coefficients, 
//of the given matrixelement which is unifrom throughout one sector 

extern char working_folder_name[400];

extern char  swap_folder_name[400]; 

extern char  delta_peaks_positive_file_name[400]; 
extern ofstream delta_peaks_positive_file_out; 
extern ifstream delta_peaks_positive_file_in; 

extern char  delta_peaks_negative_file_name[400]; 
extern ofstream delta_peaks_negative_file_out; 
extern ifstream delta_peaks_negative_file_in; 


extern char delta_peaks_odd_file_name[400];
extern ofstream delta_peaks_odd_file_out; 
extern ifstream delta_peaks_odd_file_in; 


extern char delta_peaks_even_file_name[400]; 
extern ofstream delta_peaks_even_file_out;
extern ifstream delta_peaks_even_file_in; 

extern char delta_peaks_positive_dmnrg_file_name[400];
extern ofstream delta_peaks_positive_dmnrg_file_out; 
extern ifstream delta_peaks_positive_dmnrg_file_in;

extern char delta_peaks_negative_dmnrg_file_name[400]; 
extern ofstream delta_peaks_negative_dmnrg_file_out; 
extern ifstream delta_peaks_negative_dmnrg_file_in; 


extern char spectral_function_file_name[400]; 
extern ofstream spectral_function_file_out; 


extern int interval_no; 
extern double degeneracy_threshhold;
extern double temperature; 

extern double allowed_error; 
extern int double_precision;

double log_gaussian_distribution(double x, double M, double S); 


double clebsch_gordan_coefficients_sum(int sym_no, 
				       symmetry * sym_type, 
				       sector_properties * new_block_sectors_properties_array, 
				       quantum_operator * operators,
				       int sector_row_index, 
				       int operator_index, 
				       int sector_column_index);




void generate_spectral_function_peaks_nrg(int iteration_index,
					  
					  int symmetry_no, 
					  symmetry * symmetry_types,
					  
					  int new_block_state_no,
					  state *new_block_states_array,
					  
					  int new_block_sector_no,
					  sector_properties * new_block_sectors_properties_array, 
					  
					  double * new_block_energies_array, 
					  double * sorted_new_block_energies_array,
					  unsigned long *new_block_energies_index,
					  
					  quantum_operator & spectral_operator_A,
					  quantum_operator & spectral_operator_B
					  );






void generate_spectral_function_peaks_dmnrg(int iteration_index,
					  
					    int symmetry_no, 
					    symmetry * symmetry_types,
					    
					    int new_block_state_no,
					    state *new_block_states_array,
					    
					    int new_block_sector_no,
					    sector_properties * new_block_sectors_properties_array, 
					  					  
					    double * new_block_energies_array, 
					    double * sorted_new_block_energies_array,
					    unsigned long *new_block_energies_index,
					    
					    quantum_operator & spectral_operator_A,
					    quantum_operator & spectral_operator_B,
					    quantum_operator & new_block_density_matrix
					    );


void generate_static_average_dmnrg(int iteration_index,
				   
				   int symmetry_no, 
				   symmetry * symmetry_types,
				   
				   int new_block_state_no,
				   state *new_block_states_array,
				   
				   int new_block_sector_no,
				   sector_properties * new_block_sectors_properties_array, 
				   				   
				   quantum_operator & spectral_operator_A,
				   quantum_operator & spectral_operator_B,
				   quantum_operator & new_block_density_matrix
				   );





void generate_static_average_dmnrg(int iteration_index,
				   
				   int symmetry_no, 
				   symmetry * symmetry_types,
				   
				   int new_block_state_no,
				   state *new_block_states_array,
				   
				   int new_block_sector_no,
				   sector_properties * new_block_sectors_properties_array, 
				   				   
				   quantum_operator & static_operator_A,
				   quantum_operator & new_block_density_matrix
				   );


#endif // _spectra_h_ 
