/****************************************************************************

Last Update : 2007/09/25 Pascu Moca 

Documentation update necessary


*****************************************************************************/


#include "../include/hilbert_transform.h"



void generate_fourier_coefficients(int fourier_series_order, 
				   double *even_coefficient, 
				   double *odd_coefficient,

				   int points_no,
				   double *x_array, 
				   double *f_array){



  double period = x_array[points_no-1]-x_array[0]; 
  double omega = 2*M_PI/period; 
  


  for(int n=0; n<fourier_series_order; n++){
    even_coefficient[n]=0.0;
    odd_coefficient[n] =0.0;   
  }//n


  for(int n=0; n<fourier_series_order; n++){

    for (int i=0;i<points_no-1; i++){
      even_coefficient[n] += 0.5*(f_array[i]+f_array[i+1])*(x_array[i+1]-x_array[i])*cos(0.5*n*omega*(x_array[i]+x_array[i+1])); 
      odd_coefficient[n] += 0.5*(f_array[i]+f_array[i+1])*(x_array[i+1]-x_array[i])*sin(0.5*n*omega*(x_array[i]+x_array[i+1]));  
    }//i    

    even_coefficient[n] *= 2.0/period; 
    odd_coefficient[n]  *= 2.0/period; 

  }//n
 
  return; 
}//generate_fourier_coefficient
