/****************************************************************************

Last Update : 2007/09/25 Pascu Moca 

No documentation update necessary


*****************************************************************************/


#include "../include/llvector.h"

/*----------------------------------------------------------------------------*/
/*---------------CONSTRUCTORS AND DESTRUCTORS---------------------------------*/
/*----------------------------------------------------------------------------*/

llvector::llvector(){
/*************************************************************************
llvector class:
this is a class of integers, similar with an array of integers

members:
        size - is the size of the array. the index of elements
                goes from 0 to size-1.
        ptr -   this is the pointer to the vector.

Implicit constructor for the llvector class.

input variables = none

output variables  = none

return = none

What it does:
     set the 'size' to zero and 'aptr' to NULL.

how to call:
     llvector();

****************************************************************************/

  size = 0; 
  ptr = NULL;    
}//llvector. 


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

llvector::llvector(int new_size){ 

/****************************************************************************
Implicit constructor for the llvector class.


input variables  = 1
       int new_size - this is the size of the llvector class.

output variables = none

return = none

What it does:
     set the 'size' to new_size and correspondendly allocates a pointer for 'aptr'
     of the proper size.

how to call:
     llvector(int new_size);
****************************************************************************/


  if(!ptr){
    size = new_size;
    ptr = new int[size];    
  }//if
  
  if (!ptr){ 
    cerr << "Allocation failure in llvector::llvector(int).\nEXITING..." << endl; 
    exit(1);
  }//if
}//llvector

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

llvector::~llvector(){

/****************************************************************************
Implicit destructor for the class.

input variables = none

output variables = none

return = none

What it does:
     Destroys the class llvector.

how to call:
    ~llvector();
****************************************************************************/


  if(ptr){
    delete [] ptr;
    ptr = NULL;
  }//if  
}//~llvector


/*----------------------------------------------------------------------------*/
/*-------------------MEMBERS FUNCTIONS----------------------------------------*/
/*----------------------------------------------------------------------------*/

void llvector::allocate(int new_size){

/****************************************************************************
input variables =one
      int new_size - size of the allocated llvector class

output variables = none

return =void

What it does:
     'allocate' allocates a llvector with size new_size,
     similar to a constructor. At the same time all the elements
     of the llvector class are set to zero.
how to call:
void allocate(int new_size);
****************************************************************************/
    
  if(ptr) {
    cerr << "llvector() already existing. \nError in llvector::allocate(int)\nEXITING..." << endl; 
    exit(1);
  }//if
  
  else{
    size = new_size;
    ptr = new int[size];   
  }//else
  
  if (!ptr){ 
    cerr << "Allocation failure in llvector().\nError in llvector::allocate(int)\nEXITING..." << endl; 
    exit(1);
  }
  
  //all the elements are set to zero. 
  
  for(int i = 0; i < size; i++){
    ptr[i] = 0;
  }//for i 
  
}//allocate

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void llvector::clear(){

/****************************************************************************
input variables = none

output variables = none

return =void;

What it does:
     'clear' destroys the llvector class similar with a destructor.

how to call:
    void clear();
****************************************************************************/

  if (!ptr){ 
    cerr << "llvector is not yet allocated.\nError in llvector::clear(int)\nEXITING..." << endl; 
    exit(1);
  }//if 
  else {
    delete [] ptr;
    ptr = NULL;
  }//else
}//clear


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
  
int * llvector::get_ptr(void){

/****************************************************************************
input variables = none

output variables = none

return = a pointer to an integer;

What it does:
     'get_ptr' returns the 'ptr' variable that is a pointer to an int

how to call:
    int * get_ptr();
****************************************************************************/

  return(ptr);
}//get_ptr


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

int  llvector::get_size(){

/****************************************************************************
input variables = none

output variables = none

return = an integer;

What it does:
     'get_size' returns the the size of the llvector class, that is
     the variable 'size'.

how to call:
    int get_size();
****************************************************************************/

  return(size);
}//get_size


/*----------------------------------------------------------------------------*/
/*------------------------------OPERATORS-------------------------------------*/
/*----------------------------------------------------------------------------*/
  
llvector & llvector::operator = (const int l){

/****************************************************************************
input variables = one
     const int new_value - this is the new value of all the elements

output variables = none

return = a reference to the llvector class;

What it does:
     '=' atributes to all the elements of the llvector class a given value new_value

how to call:
    llvector & operator = (const int new_value);
****************************************************************************/

  if(ptr){
    for(int i = 0; i < size; i++){
      ptr[i] = l; 
    }//for i 
  }//if
  return (* this);
}//=

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

llvector & llvector::operator ++ (){

/****************************************************************************
input variables = none

output variables = none

return = a reference to the llvector class;

What it does:
     '++' increments with one all the elements of the llvector.
how to call:
    llvector & operator ++ (void);
****************************************************************************/

  if(ptr){
    for(int i = 0; i < size; i++){
      ptr[i]++;
    }//for i
  }//if
  return (* this);
}//++

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
    
int & llvector::operator [] (int i){

/****************************************************************************
input variables = one
      int i - the 'i'-th element from the pointer ptr.
output variables = none

return = the 'i'-th element from the pointer ptr.

What it does:
     '[]' returns the 'i'-th element from the pointer ptr.
how to call:
    llvector & operator [] (int);
****************************************************************************/

  return(ptr[i]);
}//[]
    
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


llvector & llvector::operator = (llvector & V){

/****************************************************************************
input variables = one
      llvector & V- a reference to a llvector class.

output variables = none

return = the reference to the llvector class.

What it does:
     '=' is similar with a copy constructor so the input llvector
      reference variable is copied in the *this variable

how to call:
     llvector & operator = (llvector & );
****************************************************************************/

  if(V.get_size() != this->get_size()){
    cerr << V.get_size();
    cerr << "\t";
    cerr << this->get_size() << endl;
    cerr << "get_size()s of llvectors do not match\nError in llvector::operator = (llvector &)" << endl;
    exit(1);
  }//if
  
  if(ptr){
    for(int i = 0; i < size; i++){
      ptr[i] = V[i];
    }//for i
  }//if apr
  
  return (* this);
}//= 

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

ostream & llvector::print(ostream & os)	{

/****************************************************************************
****************************************************************************/

  int size = (* this).get_size();
  for(int i = 0; i < size; i++){
    os <<  (* this)[i] << " " ;
  }//i
  return os;
}//print

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

int  llvector::operator == (llvector & V){

/****************************************************************************
input variables = one
      llvector & V  - a reference to a llvector class.

output variables = none

return = 1 if the V is equal with the present llvector class variable
         0 if V does not match with the present class element.

What it does:
     '==' tests if two llvector variables are equal in all respects. If they are
     then returns 1 otherwise returns 0.

how to call:
     int operator == (llvector & );

****************************************************************************/

  int l1 = V.get_size(); 
  int l2 = get_size(); 
  
  if((l1 != l2) || (l1 == 0) ){
    return(0); 
  }
  else{
    for(int l = 0; l < l1; l++){
      if (V[l] != ptr[l]){
	return(0);
      }//if 
    }//for l 
  }//else
  
  return(1);
}//== 

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

int llvector::operator != (llvector & V){

/****************************************************************************
input variables = one
      llvector & V  - a reference to a llvector class.

output variables = none

return = 0 if the V is equal with the present llvector class variable
         1 if V does not match with the present class element.

What it does:
     '!=' tests if two llvector variables are not equal. If they are not
     equal then returns 1 otherwise returns 0.

how to call:
     int operator != (llvector & );
****************************************************************************/

  return(!(V == (* this)));
}//!=

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
    
int llvector::operator < (llvector & V2){

/****************************************************************************
input variables = one
      llvector & V  - a reference to a llvector class.

output variables = none

return = 1 if the the size of the V vector is larger than the size of the
        present class or, if the sizes are the same, then compares the
        elements.
        0 otherwise.
What it does:
     '<' tests first the sizes of the classes variables and then the
     corresponding elements one by one.

how to call:
     int operator < (llvector & );

****************************************************************************/

  int l1 = get_size(); 
  int l2 = V2.get_size(); 
  if(l1 < l2){
    return(1); 
  }//if
  else{
    if( (l1 == l2) || (l1 != 0)){
      int l = 0; 
      while (( ptr[l] == V2[l]) && (l < (l1 - 1))) l++;    
      if (ptr[l] < V2[l]) return(1);
    }//if
  }//else
  // in all other cases 
  return(0); 
}//<

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

int llvector::operator > (llvector & V2){

/****************************************************************************
input variables = one
      llvector & V - a reference to a llvector class.

output variables = none

return = 1 if the the size of the V vector is smaller than the size of the
        present class or, if the sizes are the same, then compares the
        elements.
        0 otherwise.

What it does:
     '>' tests first the sizes of the classes variables and then the
     corresponding elements one by one.

how to call:
     int operator > (llvector & );
****************************************************************************/

  return(V2 < (* this)); 
}// > 


/*----------------------------------------------------------------------------*/
/*-------------------------FRIEND FUNCTIONS-----------------------------------*/
/*----------------------------------------------------------------------------*/

 
ostream & operator << (ostream & os, llvector& V){

/****************************************************************************
input variables = two
      ostream & os -stream where the llvector class is printed
      llvector V  - a reference to a llvector class

output variables = none

return = the stream where the llvector class is printed

What it does:
     '<<' print the V llvector into the os stream. This can be a file
     or any other output redirected.

how to call:
     friend  ostream & operator << (ostream & , llvector & );
****************************************************************************/

  return(V.print(os));
}//ostream 

/*-------------------------------------------------------------------------*/
