#include "../include/sector.h"

/*******************************************************************/

sector::sector(void){ 
  height = width = 0;
}//sector

/*******************************************************************/

sector::~sector(){
}//~sector

/*******************************************************************/
    
void sector::activate(int no_of_sym){
  representation_index[0].allocate(no_of_sym);    
  representation_index[1].allocate(no_of_sym);  
}//activate

/*******************************************************************/
    
void sector::allocate_matrix() {
  matrix.allocate(height,width);
}//allocate_matrix
    
/*******************************************************************/
void sector::delete_matrix(){
  if(matrix.get_matrix_ptr()) 
    matrix.clear();
}//delete_matrix  

/*******************************************************************/
void sector::clear() {	 
	    /* remove matrix */
  if(matrix.get_matrix_ptr()) {    /* if active */
    height = width = 0; 
    representation_index[0] = 0;
    representation_index[1] = 0;
    matrix.clear(); /* if allocated then removes it */
  }//if
}//clear
/*******************************************************************/    
int sector::get_height() {
  return(height);
}//get_height

/*******************************************************************/
int sector::get_width(){
  return(width);
}
/*******************************************************************/

int sector::get_representation_index(int i, int sindex) {
  return(representation_index[i][sindex]);
}//get_representation_index

/*******************************************************************/
    
void sector::set_size (int dim1, int dim2) {
  height = dim1; 
  width = dim2;
}//set_size
    
/*******************************************************************/

dmatrix & sector::get_matrix(){
  if(matrix.get_matrix_ptr()) 
    return(matrix);
  else{
    cerr << "Matrix is not yet allocated.\nError in sector::get_matrix\nEXITING..." << endl; 
    exit(1);
  }//else  
}//get_matrix
/*******************************************************************/

void sector::set_matrix_element(int i, int j, double x){
  matrix.set_matrix_element(i,j,x);
}//set_matrix_element

/*******************************************************************/

int sector::get_activation_state(void){
  if(matrix.get_matrix_ptr()) return(1);
  else return(0);
}//get_activation_state

/*******************************************************************/

llvector & sector::get_representation_index(int i) {
  return(representation_index[i]);
}//get_representation_index

/*******************************************************************/
    
void sector::set_representation_index(int i, int sindex, int rep_index_value){ 
  representation_index[i][sindex] = rep_index_value;
}//set_representation_index

/*******************************************************************/

void sector::set_representation_index(int i,  llvector & rep_index_master){ 
  int size = representation_index[i].get_size();
  if (size != rep_index_master.get_size()) {
    cerr << "Sizes do not match.\n Error in sector::set_representation_index(int, llvector &).\nEXITING..." << endl; 
    exit(1);
  }//if
  for(int ind = 0; ind < size; ind++){
    representation_index[i][ind] = rep_index_master[ind];
  }// ind
}//set_representation_index

