/****************************************************************************

Last Update : 2007/09/27 Pascu Moca 

Documentation update necessary


*****************************************************************************/

#include "../include/transformation.h"

// matrix multiplication with LAPACK dgemm_() routine 


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void operator_transformation(int sector_no, quantum_operator& one_operator, sector * transformation_sectors){


/*******************************************************************************
input variables:  two
    int sector_no                   - ???
    sector * transformation_sectors - ???

output variables: one
    quantum_operator& one_operator  - ??? 

return: void

What it does:
    ???
How to call:
*******************************************************************************/
  for(int sector_row = 0; sector_row < sector_no; sector_row++) 
    for(int sector_column = 0; sector_column < sector_no; sector_column++)

      if(one_operator.get_sector_matrix()[sector_row][sector_column].get_activation_state()){

	
	/* c = alpha * op(a) * op(b) + beta * c */ 
	
	char transa = 'N';
	char transb = 'N';
	int row_a = one_operator.get_sector_matrix()[sector_row][sector_column].get_height();
	int col_b = transformation_sectors[sector_column].get_width(); 
	int col_a = one_operator.get_sector_matrix()[sector_row][sector_column].get_width();
	int row_b = col_a;
	double alpha = 1;
	double beta = 0;
	int lda = row_a; /* 1^st dimension of a */
	int ldb = row_b; /* 1^st dimension of b */
	int ldc = row_a; /* 1^st dimension of c */
	
	double ** a_l;
	a_l = new double * [col_a];
	a_l[0] = new double [col_a * row_a];
	for(int ii = 1; ii < col_a; ii++)
	  a_l[ii] = a_l[0] + ii * row_a;
	
	double ** b_l;
	b_l = new double * [col_b];
	b_l[0] = new double [col_b * row_b];
	for (int ii = 1; ii < col_b; ii++)
	  b_l[ii] = b_l[0] + ii * row_b;
	
	double ** c_l;
	c_l = new double * [col_b];
	c_l[0] = new double [col_b * row_a];
	for (int ii = 1; ii < col_b; ii++)
	  c_l[ii] = c_l[0] + ii * row_a;        
	
	
	for(int ii = 0; ii < col_a; ii++)
	  for(int jj = 0; jj < row_a; jj++)
	    a_l[ii][jj] = one_operator.get_sector_matrix()[sector_row][sector_column].get_matrix()[jj][ii];
	
	
	for(int ii = 0; ii < col_b; ii++)
	  for(int jj = 0; jj < row_b; jj++)
	    b_l[ii][jj] = transformation_sectors[sector_column].get_matrix()[jj][ii];
	
	
	dgemm_( & transa, 
	       & transb, 
	       & row_a, 
	       & col_b, 
	       & col_a, 
	       & alpha,
	       * a_l, 
	       & lda,
	       * b_l, 
	       & ldb,
	       & beta, 
	       * c_l,
	       & ldc);
	
	
	for(int jj = 0; jj < row_a; jj++){
	  for(int ii = 0; ii < col_b; ii++){
	    one_operator.get_sector_matrix()[sector_row][sector_column].set_matrix_element(jj, ii,  c_l[ii][jj]);
	  }//ii			
	}//jj
		
	delete [] a_l[0];
	a_l[0] = NULL;
	
	delete []  a_l;
	 a_l = NULL;
	
	delete [] b_l[0];
	b_l[0] = NULL;
	
	delete []  b_l;
	 b_l = NULL;
	
	delete [] c_l[0];
	c_l[0] = NULL;
	
	delete []  c_l;
	 c_l = NULL;
	
	transa = 'T';
	transb = 'N';

	row_a = transformation_sectors[sector_row].get_height();
	col_b = one_operator.get_sector_matrix()[sector_row][sector_column].get_width(); 
	col_a = transformation_sectors[sector_row].get_width();
	row_b = col_a;
	alpha = 1;
	beta = 0;
	lda = row_a; // 1^st dimension of a 
	ldb = row_b; // 1^st dimension of b 
	ldc = row_a; // 1^st dimension of c

	a_l = new double * [col_a];
	a_l[0] = new double [col_a * row_a];
	for(int ii = 1; ii < col_a; ii++)
	  a_l[ii] = a_l[0] + ii * row_a;

	b_l = new double * [col_b];
	b_l[0] = new double [col_b * row_b];
	for (int ii = 1; ii < col_b; ii++)
	  b_l[ii] = b_l[0] + ii * row_b;

	c_l = new double * [col_b];
	c_l[0] = new double [col_b * row_a];
	for (int ii = 1; ii < col_b; ii++)
	  c_l[ii] = c_l[0] + ii * row_a;        
	

	for(int ii = 0; ii < col_a; ii++)
	  for(int jj = 0; jj < row_a; jj++)
	    a_l[ii][jj] = transformation_sectors[sector_row].get_matrix()[jj][ii];

	for(int ii = 0; ii < col_b; ii++)
	  for(int jj = 0; jj < row_b; jj++)
	    b_l[ii][jj] = one_operator.get_sector_matrix()[sector_row][sector_column].get_matrix()[jj][ii];

	dgemm_(& transa, 
	      & transb, 
	      & row_a, 
	      & col_b, 
	      & col_a, 
	      & alpha,
	      * a_l, 
	      & lda,
	      * b_l, 
	      & ldb,
	      & beta, 
	      * c_l,
	      & ldc);
	
	for(int jj = 0; jj < row_a; jj++) {
	  for(int ii = 0; ii < col_b; ii++){
	    one_operator.get_sector_matrix()[sector_row][sector_column].set_matrix_element(jj, ii,  c_l[ii][jj]);
	  }//ii
	}//jj
		 
	delete [] a_l[0];
	a_l[0] = NULL;
	delete []  a_l;
	 a_l = NULL;
	delete [] b_l[0];
	b_l[0] = NULL;
	delete []  b_l;
	 b_l = NULL;
	delete [] c_l[0];
	c_l[0] = NULL;
	delete []  c_l;
	 c_l = NULL;
      }//if one_operator
}//transform


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void generate_energy_index_table(int new_block_state_no, double* energies, unsigned long* energy_index){

/*******************************************************************************
input variables:  two
    int new_block_state_no            - ???
    double* energies            - 
    unsigned long* energy_index -  


output variables: none

return: void

What it does:
    ???
How to call:
*******************************************************************************/

  indexx((unsigned long) new_block_state_no, energies-1, energy_index-1); 
}//generate_energy_index_table


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void generate_energy_index_table_mod(int new_block_state_no, double* energies, unsigned long* energy_index){

/*******************************************************************************
input variables:  two
    int new_block_state_no            - ???
    double* energies            - 
    unsigned long* energy_index -  


output variables: none

return: void

What it does:
    ???
How to call:
*******************************************************************************/

  /* we call the numerical recipies routine */ 
  indexx((unsigned long) new_block_state_no, energies-1, energy_index-1);
  
  /* now we shift back the labels by one to compensate the convention of numerical recipies */

  for(long i=0; i < new_block_state_no; i++ )  energy_index[i]--; 
  
  
}//generate_energy_index_table_mod


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void sort_energies(int new_block_state_no, double *energies, double * sorted_energies){

/*******************************************************************************
input variables:  two
    int new_block_state_no        - ???
    double* energies        - 
    double* sorted_energies -  


output variables: none

return: void

What it does:
    ???
How to call:
*******************************************************************************/

  for (int index=0; index<new_block_state_no; index++){
    sorted_energies[index]= energies[index]; 
  }//index
  
  hpsort ((unsigned long)new_block_state_no, sorted_energies-1); 

  
  /*
  double ground_state_energy = sorted_energies[0];

  for (int index=0; index<new_block_state_no; index++){
    energies[index] -= ground_state_energy;
    sorted_energies[index] -= ground_state_energy;
  }
  */
}//sort_energies


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void check_orthogonality(int sector_no, sector * transformation_sectors){

/*******************************************************************************
input variables:  two
    int new_block_state_no               - ???
    sector* transformation_sectors - 

output variables: none

return: void

What it does:
    ???
How to call:
*******************************************************************************/
  
  for(int sector_index = 0; sector_index < sector_no; sector_index++){
    
    char transa = 'T';
    char transb = 'N';
  
    
    int row_a = transformation_sectors[sector_index].get_height();
    int col_b = transformation_sectors[sector_index].get_width(); 
    int col_a = transformation_sectors[sector_index].get_width();
    int row_b = col_a;
    
    
    double alpha = 1;
    double beta = 0;
    int lda = row_a; // 1^st dimension of a 
    int ldb = row_b; // 1^st dimension of b 
    int ldc = row_a; // 1^st dimension of c
    
    double ** a_l;
    a_l = new double * [col_a];
    a_l[0] = new double [col_a * row_a];
    for(int ii = 1; ii < col_a; ii++)
      a_l[ii] = a_l[0] + ii * row_a;

    double ** b_l;    
    b_l = new double * [col_b];
    b_l[0] = new double [col_b * row_b];
    for (int ii = 1; ii < col_b; ii++)
      b_l[ii] = b_l[0] + ii * row_b;

    double ** c_l;    
    c_l = new double * [col_b];
    c_l[0] = new double [col_b * row_a];
    for (int ii = 1; ii < col_b; ii++)
      c_l[ii] = c_l[0] + ii * row_a;        
    
    
    for(int ii = 0; ii < col_a; ii++)
      for(int jj = 0; jj < row_a; jj++)
	a_l[ii][jj] = transformation_sectors[sector_index].get_matrix()[jj][ii];
    
    for(int ii = 0; ii < col_b; ii++)
      for(int jj = 0; jj < row_b; jj++)
	b_l[ii][jj] = transformation_sectors[sector_index].get_matrix()[jj][ii];
    
    dgemm_(& transa, 
	   & transb, 
	   & row_a, 
	   & col_b, 
	   & col_a, 
	   & alpha,
	   * a_l, 
	   & lda,
	   * b_l, 
	   & ldb,
	   & beta, 
	   * c_l,
	   & ldc);
    
    //cout<<sector_index<<endl;
    for(int jj = 0; jj < row_a; jj++) {
      //printf("%15.14lf\n", c_l[jj][jj]);
      assert(fabs(c_l[jj][jj]-1)<allowed_error); 
      for(int ii = 0; ii < col_b; ii++){
	if (ii==jj) continue; 
	//printf("%15.14lf  ", c_l[ii][jj]);
	assert(fabs(c_l[ii][jj])<allowed_error); 
      }//ii
      //printf("\n"); 
    }//jj
    //getchar();
    delete [] a_l[0];
    a_l[0] = NULL;
    delete []  a_l;
     a_l = NULL;
    delete [] b_l[0];
    b_l[0] = NULL;
    delete []  b_l;
     b_l = NULL;
    delete [] c_l[0];
    c_l[0] = NULL;
    delete []  c_l;
     c_l = NULL;
  }//for sector_index; 

}//chech_orthogonality


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void substract_ground_state_energy(int sector_no, 
				   sector_properties *sectors_properties_array, 
				   quantum_operator & block_hamiltonian, 
				   double * energies_array,
				   double * sorted_energies_array){
  





  int eigen_energy_index = 0;  
  double matrix_element;
  double ground_state_energy = sorted_energies_array[0];

  for(int sector_label = 0; sector_label < sector_no; sector_label++){
    int sector_size = (int)sectors_properties_array[sector_label].dimension;     

      for(int i = 0; i < sector_size; i++){
      for(int j = 0; j < sector_size; j++){
	matrix_element = (double)block_hamiltonian.get_sector_matrix()[sector_label][sector_label].get_matrix()[j][i];
	matrix_element -= ground_state_energy; 
	block_hamiltonian.get_sector_matrix()[sector_label][sector_label].set_matrix_element(i, j,  matrix_element);
      }//j
    }//i

  }//sector_label







}//substract_ground_state_energy
